/* amiga_display.c -- Initialisation for Amiga window-system
   Copyright (C) 1993, 1994 John Harper <jsh@ukc.ac.uk>

This file is part of Jade.

Jade is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Jade is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jade; see the file COPYING.	If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "jade.h"
#include "jade_protos.h"

#include <string.h>
#include <stdlib.h>
#include <exec/libraries.h>

_PR void sys_usage(void);
_PR int initwinsys(int *, char ***);
_PR void killwinsys(void);

extern	struct Library *SysBase;
_PR bool FromWB;
    bool FromWB;
_PR short OSVer;
    short OSVer;

_PR VALUE DefFontStr, DefPubScreen;
VALUE DefFontStr = MKSTR(DEFAULT_FONT), DefPubScreen;
_PR int DefFontSize;
int DefFontSize = DEFAULT_FONT_SIZE;

void
sys_usage(void)
{
    fputs("where SYSTEM-OPTIONS are,\n"
	"    -pubscreen SCREEN\n"
	"    -font FONT   FONT is something like `topaz.font-8'\n"
	, stderr);
}

int
initwinsys(int *argc_p, char ***argv_p)
{
    int argc;
    char **argv;
    if(*argc_p == 0)
	FromWB = TRUE;
    else
    {
	(*argc_p)--;
	(*argv_p)++;
    }
    if((OSVer = SysBase->lib_Version) < 37)
    {
	doconmsg("error: need system version 2.04 or greater\n");
	return(FALSE);
    }
    argc = *argc_p;
    argv = *argv_p;
    DefPubScreen = NullString;
    while((argc >= 1) && (**argv == '-'))
    {
	if(argc >= 2)
	{
	    if(!strcmp("-pubscreen", *argv))
		DefPubScreen = valstrdup(argv[1]);
	    else if(!strcmp("-font", *argv))
	    {
		char *tmp = strrchr(argv[1], '-');
		if(!tmp)
		{
		    doconmsg("error: no size in `-font' arg\n");
		    return(FALSE);
		}
		DefFontSize = atol(tmp+1);
		DefFontStr = valstrdupn(argv[1], tmp - argv[1]);
	    }
	    else
		break;
	    argc--; argv++;
	}
	else
	    break;
	argc--; argv++;
    }
    *argc_p = argc;
    *argv_p = argv;
    rexx_init();
    ami_menus_init();
    return(TRUE);
}

void
killwinsys(void)
{
    killclipstuff();
    killfilereq();
    ami_menus_kill();
    rexx_kill();
}

#ifdef _DCC
/*
 * I think this is what DICE's wbmain() is like? All I want to
 * do is call main() with argc=0
 */
void
wbmain(void *unused)
{
    char *argv[1];
    argv[0] = NULL;
    main(0, argv);
}
#endif
